## 控制文件
oracle控制文件是一个跟踪数据库的物理组成的二进制文件，仅与一个数据库相关联，每个数据库有唯一的控制文件，可以维护多个相同的拷贝。控制文件是oracle数据库用来查找数据库文件，并从总体上管理漱口状态的根文件。控制文件包含以下信息：
* 数据库名称和数据库唯一标识符（DBID）
* 创建数据库的时间戳
* 有关数据库文件、联机重做日志、归档日志的信息
* 表空间信息
* RMAN备份信息
* 备份信息等

### 重建控制文件

查看对应的数据库名称
```sql
create pfile from spfile;
```
```sh
cat /opt/oracle/product/12.2.0.1/dbhome_1/dbs/initHOEGH.ora  # 查看db_name
```

```sql
startup nomount
select userenv('language') from dual;
```
在对应数据库文件夹
```sh
ls -lh  ## /opt/oracle/oradata/orcl/
```
生成创建控制文件脚本，然后执行生成的sql脚本就行
